/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2009 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.blackberry.autotest;

import net.rim.device.api.system.Bitmap;
import net.rim.device.api.ui.Field;
import net.rim.device.api.ui.Font;
import net.rim.device.api.ui.MenuItem;
import net.rim.device.api.ui.component.BitmapField;
import net.rim.device.api.ui.component.LabelField;
import net.rim.device.api.ui.component.Menu;
import net.rim.device.api.ui.component.RichTextField;
import net.rim.device.api.ui.container.MainScreen;
import net.rim.device.api.ui.UiApplication;

import com.funambol.blackberry.ui.rim.RimHelper;
import com.funambol.util.StaticDataHelper;

public class ReportScreen extends MainScreen {

    private final MenuItem exitMenu = new MenuItem("Exit", 20000, 10) {
                                              public void run() {
                                                  System.exit(0);
                                              }
                                          };

    public ReportScreen(boolean passed, String details) {
        
        this.setFont(RimHelper.getDefaultFont());
        
        LabelField title = new LabelField("Test Report");

        title.setFont(getFont().derive(StaticDataHelper.TITLE_FONT_STYLE,
                StaticDataHelper.TITLE_FONT_SIZE));
        setTitle(title);

        RichTextField passedLabel = new RichTextField(
                passed ? "PASSED" : "FAILED",
                Field.FIELD_HCENTER | RichTextField.TEXT_ALIGN_HCENTER | Field.NON_FOCUSABLE);
        passedLabel.setEditable(false);
        passedLabel.setFont(getFont().derive(Font.BOLD));
        add(passedLabel);

        // add blank space
        add(new LabelField(""));

        RichTextField detailsLabel = new RichTextField(
                details,
                Field.FIELD_HCENTER | RichTextField.TEXT_ALIGN_HCENTER | Field.NON_FOCUSABLE);
        detailsLabel.setEditable(false);
        detailsLabel.setFont(getFont().derive(Font.BOLD));
        add(detailsLabel);
    }

    public void makeMenu(Menu menu, int instance) {
        menu.add(exitMenu);
    }
}
