/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2008 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.blackberry;

import net.rim.blackberry.api.invoke.Invoke;
import net.rim.blackberry.api.invoke.ApplicationArguments;
import net.rim.blackberry.api.invoke.AddressBookArguments;
import net.rim.blackberry.api.invoke.CalendarArguments;
import net.rim.blackberry.api.invoke.TaskArguments;
import net.rim.blackberry.api.invoke.MemoArguments;

public class ExternalAppManager {

    private AppSyncSource source;

    public ExternalAppManager(AppSyncSource source) {
        this.source = source;
    }

    public void launch() throws Exception {
        int appId = -1;
        ApplicationArguments arg = null;

        switch (source.getId()) {
            case AppSyncSourceManager.SYNC_FLAG_CONTACTS:
                arg = new AddressBookArguments();
                appId = Invoke.APP_TYPE_ADDRESSBOOK;
                break;
            case AppSyncSourceManager.SYNC_FLAG_CALENDAR:
                arg = new CalendarArguments();
                appId = Invoke.APP_TYPE_CALENDAR;
                break;
            case AppSyncSourceManager.SYNC_FLAG_TASKS:
                arg = new TaskArguments();
                appId = Invoke.APP_TYPE_TASKS;
                break;
            case AppSyncSourceManager.SYNC_FLAG_NOTES:
                arg = new MemoArguments();
                appId = Invoke.APP_TYPE_MEMOPAD;
                break;
            default:
                // Throw an exception here
        }
        // If we get here we found the proper application
        Invoke.invokeApplication(appId, arg);
    }
}
