/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

package com.funambol.blackberry.helper;

import java.util.Calendar;
import java.util.TimeZone;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;


import net.rim.device.api.i18n.SimpleDateFormat;

import javax.microedition.pim.RepeatRule;
import javax.microedition.pim.FieldEmptyException;
import javax.microedition.pim.PIMException;

import com.funambol.util.XmlUtil;
import com.funambol.util.Log;
import com.funambol.util.DateUtil;
import com.funambol.util.StaticDataHelper;

public class SIFRepeatRuleHelper 
{
    private static final int                Months[][]                              = {{1,RepeatRule.JANUARY}
                                                                                        ,{2,RepeatRule.FEBRUARY}
                                                                                        ,{3,RepeatRule.MARCH}
                                                                                        ,{4,RepeatRule.APRIL}
                                                                                        ,{5,RepeatRule.MAY}
                                                                                        ,{6,RepeatRule.JUNE}
                                                                                        ,{7,RepeatRule.JULY}
                                                                                        ,{8,RepeatRule.AUGUST}
                                                                                        ,{9,RepeatRule.SEPTEMBER}
                                                                                        ,{10,RepeatRule.OCTOBER}
                                                                                        ,{11,RepeatRule.NOVEMBER}
                                                                                        ,{12,RepeatRule.DECEMBER}
                                                                                    };
    private static final int                Weeks[][]                               = {{1,RepeatRule.FIRST}
                                                                                        ,{2,RepeatRule.SECOND}
                                                                                        ,{3,RepeatRule.THIRD}
                                                                                        ,{4,RepeatRule.FOURTH}
                                                                                        ,{5,RepeatRule.FIFTH}
                                                                                        ,{-5,RepeatRule.FIFTHLAST}
                                                                                        ,{-4,RepeatRule.FOURTHLAST}
                                                                                        ,{-3,RepeatRule.THIRDLAST}
                                                                                        ,{-2,RepeatRule.SECONDLAST}
                                                                                        ,{-1,RepeatRule.LAST}
                                                                                    };
    private static final int                Days[][]                                = {{1,RepeatRule.SUNDAY}
                                                                                        ,{2,RepeatRule.MONDAY}
                                                                                        ,{4,RepeatRule.TUESDAY}
                                                                                        ,{8,RepeatRule.WEDNESDAY}
                                                                                        ,{16,RepeatRule.THURSDAY}
                                                                                        ,{32,RepeatRule.FRIDAY}
                                                                                        ,{64,RepeatRule.SATURDAY}
                                                                                    };

    private static final int                olRecursDaily                           = 0;
    private static final int                olRecursWeekly                          = 1;
    private static final int                olRecursMonthly                         = 2;
    private static final int                olRecursMonthlyNth                      = 3;
    private static final int                olRecursYearly                          = 5;
    private static final int                olRecursYearlyNth                       = 6;

    private static final String             RECURRENCE_TYPE                         = "RecurrenceType";                 // enhancement
    private static final String             INTERVAL                                = "Interval";                       // enhancement
    private static final String             MONTH_OF_YEAR                           = "MonthOfYear";                    // enhancement
    private static final String             DAY_OF_MONTH                            = "DayOfMonth";                     // enhancement
    private static final String             DAY_OF_WEEK_MASK                        = "DayOfWeekMask";                  // enhancement        
    private static final String             INSTANCE                                = "Instance";                       // enhancement
    private static final String             PATTERN_START_DATE                      = "PatternStartDate";               // enhancement
    private static final String             NO_END_DATE                             = "NoEndDate";                      // enhancement
    private static final String             PATTERN_END_DATE                        = "PatternEndDate";                 // enhancement
    private static final String             OCCURRENCES                             = "Occurrences";                    // enhancement
    public static final String              EXCEPTIONS                              = "Exceptions";
    public static final String              EXCLUDE_DATE                            = "ExcludeDate";
    public static final String              INCLUDE_DATE                            = "IncludeDate";

    //private static final String             DATETIME_FORMAT_UTC                     = "yyyyMMdd'T'HHmmss'Z'";
    private static final String             DATETIME_FORMAT_LOCAL                   = "yyyyMMdd";

    
    private static int processINSTANCE(RepeatRule rule) throws PIMException
    {
        int instance = 0;
        final int valueFromDevice = rule.getInt(RepeatRule.WEEK_IN_MONTH);
        for(int i=0;i<SIFRepeatRuleHelper.Weeks.length;i++)
        {
            if (valueFromDevice == SIFRepeatRuleHelper.Weeks[i][1])
            {
                instance = SIFRepeatRuleHelper.Weeks[i][0];
                break;
            }
        }
        if (instance==0)
        {
            throw new PIMException("Invalid value for RepeatRule.WEEK_IN_MONTH field ["+valueFromDevice+"]");
        }
        return instance;
    }
    
    private static int processMONTH_OF_YEAR(RepeatRule rule)
    {
        int month = SIFRepeatRuleHelper.Months[0][0];
        final int valueFromDevice = rule.getInt(RepeatRule.MONTH_IN_YEAR);
        for(int i=0;i<SIFRepeatRuleHelper.Months.length;i++)
        {
            if (valueFromDevice == SIFRepeatRuleHelper.Months[i][1])
            {
                month = SIFRepeatRuleHelper.Months[i][0];
                break;
            }
        }
        return month;
    }
    
    private static int processDAY_OF_WEEK_MASK(RepeatRule rule)
    {
        int mask = 0;
        if (rule.getInt(RepeatRule.FREQUENCY) == RepeatRule.DAILY
            || rule.getInt(RepeatRule.FREQUENCY) == RepeatRule.WEEKLY
            || rule.getInt(RepeatRule.FREQUENCY) == RepeatRule.MONTHLY
            || rule.getInt(RepeatRule.FREQUENCY) == RepeatRule.YEARLY)
        {
            final int valueFromDevice = rule.getInt(RepeatRule.DAY_IN_WEEK);
            for(int i=0;i<SIFRepeatRuleHelper.Days.length;i++)
            {
                if ((valueFromDevice & SIFRepeatRuleHelper.Days[i][1]) == SIFRepeatRuleHelper.Days[i][1])
                {
                    mask+= SIFRepeatRuleHelper.Days[i][0];
                }
            }
        }
        return mask;
    }
    
    private static int processRECURRENCE_TYPE(RepeatRule rule)
    {
        int type = SIFRepeatRuleHelper.olRecursDaily;
        // OlRecurrenceType
        switch (rule.getInt(RepeatRule.FREQUENCY))
        {
            case RepeatRule.DAILY:
                type = SIFRepeatRuleHelper.olRecursDaily;
                break;
            case RepeatRule.WEEKLY:
                type = SIFRepeatRuleHelper.olRecursWeekly;
                break;
            case RepeatRule.MONTHLY:
                try
                {
                    rule.getInt(RepeatRule.WEEK_IN_MONTH);
                }
                catch (final FieldEmptyException f)
                {
                    type = SIFRepeatRuleHelper.olRecursMonthly;
                    break;
                }
                type = SIFRepeatRuleHelper.olRecursMonthlyNth;
                break;
            case RepeatRule.YEARLY:
                try
                {
                    rule.getInt(RepeatRule.WEEK_IN_MONTH);
                }
                catch (final FieldEmptyException f)
                {
                    type = SIFRepeatRuleHelper.olRecursYearly;
                    break;
                }
                type = SIFRepeatRuleHelper.olRecursYearlyNth;
                break;
        }
        return type;
    }
    
    private static String processExcludeDate(RepeatRule rule)
    {
        final StringBuffer exDates = new StringBuffer();
        SimpleDateFormat formatter = new SimpleDateFormat(SIFRepeatRuleHelper.DATETIME_FORMAT_LOCAL);
        Enumeration excludeDates = rule.getExceptDates();
        while(excludeDates.hasMoreElements())
        {
            Calendar cal = Calendar.getInstance();
            cal.setTime((Date)excludeDates.nextElement());
            XmlUtil.addElementNewLine(exDates, SIFRepeatRuleHelper.EXCLUDE_DATE
                        ,PIMItemHelper.formatDateTimeUTC(cal)
                        ,false);
        }
        formatter = null;
        excludeDates = null;
        return exDates.toString();
    }
    
    public static Calendar getEndDate(RepeatRule rule) throws PIMException
    {
        long localTime = 0;
        try {
            localTime = rule.getDate(RepeatRule.END);
        } catch(final FieldEmptyException e)
        {}
        if (localTime > 0)
        {

            // Pattern start date and end date must be expressed in local time
            // to avoid TZ issues (bug #7322)
            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            cal.setTime(new Date(localTime));
            return cal;

            // By using a calendar with GMT timezone, we automatically convert
            // from local to GMT. Therefore the output date is expressed in GMT
            /*
            Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
            cal.setTime(new Date(localTime));
            return cal;
            */
        }
        return null;
    }

    private static Calendar getEndDateAllDay(RepeatRule rule) throws PIMException
    {
        long localTime = 0;
        try {
            localTime = rule.getDate(RepeatRule.END);
        } catch(final FieldEmptyException e)
        {}
        if (localTime > 0)
        {
            Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
            cal.setTime(new Date(localTime));
            return cal;
        }
        return null;
    }


    public static String toString(RepeatRule rule, String patternStart, String milestoneDateTime) throws PIMException
    {
        return toString(rule, patternStart, milestoneDateTime, false);
    }
    
    public static String toString(RepeatRule rule, String patternStart,
                                  String milestoneDateTime, boolean allDay) throws PIMException
    {
        boolean hasMonthInYear = false;
        boolean hasDayInMonth = false;
        long milestone = PIMItemHelper.parseDateTime(milestoneDateTime).getTime().getTime();
        int noEndDate = 1;
        int recType = 0;
        int recInstance = 0;
        final StringBuffer eventBuffer = new StringBuffer();
        int[] fieldsArray = rule.getFields();
                        
        for (int i = 0; i < fieldsArray.length; i++)
        {
            switch (fieldsArray[i])
            {
                // <RecurrenceType>
                case RepeatRule.FREQUENCY:
                    recType=SIFRepeatRuleHelper.processRECURRENCE_TYPE(rule); 
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.RECURRENCE_TYPE,""+recType,false);
                    break;

                // <Interval>
                case RepeatRule.INTERVAL:
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.INTERVAL
                        ,""+rule.getInt(RepeatRule.INTERVAL)
                        ,false);
                    break;
                                        
                // <PatternEndDate>
                case RepeatRule.END:
                    Calendar localCal;
                    if (allDay) {
                        localCal = getEndDateAllDay(rule);
                        // We must generate a pattern end date that terminates at
                        // midnight for all day events
                        localCal = PIMItemHelper.getEndOfDay(localCal);
                    } else {
                        localCal = getEndDate(rule);
                    }
                    if (localCal!=null)
                    {
                        XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.PATTERN_END_DATE
                            ,PIMItemHelper.formatDateTime(localCal)
                            ,false);
                        noEndDate = 0;
                    }
                    break;

                // <Occurrences>
                case RepeatRule.COUNT:
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.OCCURRENCES
                        ,""+rule.getInt(RepeatRule.COUNT)
                        ,false);
                    break;
                                        
                // <Instance> (limited to 1-5 due to SIF-E limitations)
                case RepeatRule.WEEK_IN_MONTH:
                    recInstance = SIFRepeatRuleHelper.processINSTANCE(rule);
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.INSTANCE,""+recInstance,false);
                    break;

                // <DayOfWeekMask>
                case RepeatRule.DAY_IN_WEEK:
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.DAY_OF_WEEK_MASK
                        ,""+SIFRepeatRuleHelper.processDAY_OF_WEEK_MASK(rule)
                        ,false);
                    break;

                // <DayOfMonth>
                case RepeatRule.DAY_IN_MONTH:
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.DAY_OF_MONTH
                        ,""+rule.getInt(RepeatRule.DAY_IN_MONTH)
                        ,false);
                    hasDayInMonth = true;
                    break;
                                        
                // <MonthOfYear> 1-12
                case RepeatRule.MONTH_IN_YEAR:
                    XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.MONTH_OF_YEAR
                        ,""+SIFRepeatRuleHelper.processMONTH_OF_YEAR(rule)
                        ,false);
                    hasMonthInYear = true;
                    break;
            }// end external switch
        }// end for loop

        // NoRelative recurrence for Monthly or Yearly
        if (recType == SIFRepeatRuleHelper.olRecursMonthly || recType == SIFRepeatRuleHelper.olRecursYearly)
        {
            Calendar localCal = Calendar.getInstance();
            localCal.setTime(new Date(milestone));
            if (!hasDayInMonth)
            {
                XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.DAY_OF_MONTH,""+localCal.get(Calendar.DAY_OF_MONTH),false);
            }
            if (!hasMonthInYear && recType == SIFRepeatRuleHelper.olRecursYearly)
            {
                int month = localCal.get(Calendar.MONTH)+1;
                XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.MONTH_OF_YEAR,""+month,false);
            }
        }
        
        /*
        * the pattern start date isn't accessible through the RIM's API, so
        * we take the same value as the start date
        */
        XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.PATTERN_START_DATE, patternStart, false);

        /*
        * <NoEndDate>1</NoEndDate> if <PatternEndDate> doesn't exist. If
        * <PatternEndDate> does exist, noEnd is set to 0 in the appropriate
        * section above
        */
        XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.NO_END_DATE, ""+noEndDate, false);
        
        eventBuffer.append(XmlUtil.createOpenTagNewLine(SIFRepeatRuleHelper.EXCEPTIONS));
        eventBuffer.append(SIFRepeatRuleHelper.processExcludeDate(rule));
        XmlUtil.addElementNewLine(eventBuffer, SIFRepeatRuleHelper.INCLUDE_DATE, "", false);
        eventBuffer.append(XmlUtil.createCloseTagNewLine(SIFRepeatRuleHelper.EXCEPTIONS));
        fieldsArray = null;
        return eventBuffer.toString();
    }
    
    
    
    
    
    
    private static int parseINSTANCE(int instance) throws PIMException
    {
        boolean found = false;
        int weekth = 0;
        for(int i=0;i<SIFRepeatRuleHelper.Weeks.length;i++)
        {
            if (instance == SIFRepeatRuleHelper.Weeks[i][0])
            {
                weekth = SIFRepeatRuleHelper.Weeks[i][1];
                found = true;
                break;
            }
        }
        if (!found)
        {
            throw new PIMException("Invalid value for SIF.Instance field ["+instance+"]");
        }
        return weekth;
    }
    
    private static int parseMONTH_OF_YEAR(int monthOfYear)
    {
        int month = 0;
        for(int i=0;i<SIFRepeatRuleHelper.Months.length;i++) {
            if (monthOfYear == SIFRepeatRuleHelper.Months[i][0]) {
                month = SIFRepeatRuleHelper.Months[i][1];
                break;
            }
        }
        return month;
    }
    
    private static int parseDAY_OF_WEEK_MASK(int dayofweekmask)
    {
        int mask = 0;
        for(int i=0;i<SIFRepeatRuleHelper.Days.length;i++)
        {
            if ((dayofweekmask & SIFRepeatRuleHelper.Days[i][0]) == SIFRepeatRuleHelper.Days[i][0])
            {
                mask = mask + SIFRepeatRuleHelper.Days[i][1];
            }
        }
        return mask;
    }
    
    private static String SettingFieldName = null;
    
    public static String popSettingFieldName()
    {
        String ret = SIFRepeatRuleHelper.SettingFieldName;
        SIFRepeatRuleHelper.SettingFieldName = null;
        return ret;
    }

    public static int getRecurrenceType(Hashtable eventMap)
    {
        final String recurrenceType = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.RECURRENCE_TYPE, false);// 1-6
        if (!"".equals(recurrenceType))
        {
            return Integer.parseInt(recurrenceType);
        }
        return 0;
    }
    
    public static boolean isWeeklyRecurrence(int recurType)
    {
        switch (recurType)
        {
            case olRecursWeekly:
                return true;
        }
        return false;
    }

    public static boolean isMonthlyNthRecurrence(int recurType)
    {
        switch (recurType)
        {
            case olRecursMonthlyNth:
                return true;
        }
        return false;
    }

    public static boolean isYearlyNthRecurrence(int recurType)
    {
        switch (recurType)
        {
            case olRecursYearlyNth:
                return true;
        }
        return false;
    }

    public static void setRepeatRule(Hashtable eventMap, RepeatRule rule,
                                     boolean extraGMTToLocal) throws PIMException
    {
        setRepeatRule(eventMap, rule, extraGMTToLocal, false);
    }
 

    public static void setRepeatRule(Hashtable eventMap, RepeatRule rule,
                                     boolean extraGMTToLocal,
                                     boolean allDay) throws PIMException
    {
        // This is currently not supported by the RIM API
        // <PatternStartDate>
        // 20060706T220000Z
        // final String patternStartDate = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.PATTERN_START_DATE, false);

        // <RecurrenceType>
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.RECURRENCE_TYPE;
        final String recurrenceType = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.RECURRENCE_TYPE, false);// 1-6
        int intervalFactor = 1;
        int type = 0;
        int olRecType = -1;

        if (!"".equals(recurrenceType)) {
            olRecType = Integer.parseInt(recurrenceType);
        }

        Log.trace("olRecType=" + olRecType);

        if (olRecType != -1) {
            switch (olRecType)
            {
                case olRecursDaily:
                    type = RepeatRule.DAILY;
                    break;
                case olRecursWeekly:
                    type = RepeatRule.WEEKLY;
                    break;
                case olRecursMonthly:
                    type = RepeatRule.MONTHLY;
                    break;
                case olRecursMonthlyNth:
                    type = RepeatRule.MONTHLY;
                    break;
                case olRecursYearly:
                    type = RepeatRule.YEARLY;
                    //type = RepeatRule.MONTHLY;
                    //intervalFactor = 12;
                    break;
                case olRecursYearlyNth:
                {
                    // On OS >= 4.2 there is a bug that prevents these events
                    // to be stored properly.
                    // With this patch we transform these events from yearly to
                    // monthly every 12 months
                    boolean patch = false;
                    String version[] = StaticDataHelper.getOSVersion();

                    if (version.length > 1) {
                        int major = Integer.parseInt(version[0]);
                        int minor = Integer.parseInt(version[1]);
                        if (major == 4 && minor >= 2) {
                            patch = true;
                        }
                    }

                    if (patch) {
                        Log.trace("Applying patch for recurring events on relative dates");
                        type = RepeatRule.MONTHLY;
                        intervalFactor = 12;
                        eventMap.remove(SIFRepeatRuleHelper.MONTH_OF_YEAR);
                        eventMap.put(SIFRepeatRuleHelper.MONTH_OF_YEAR, "");
                    } else {
                        type = RepeatRule.YEARLY;
                    }
                    break;
                }
                default:
                    Log.error("Unknown recurrence type: " + olRecType);
                    break;
            }
            Log.trace("Setting FREQUENCY to: " + type);
            rule.setInt(RepeatRule.FREQUENCY, type);
        }

        // <Interval>
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.INTERVAL;
        final String interval = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.INTERVAL, false);
        if (!"".equals(interval) && !"0".equals(interval)) {
            Log.trace("Setting INTERVAL to: " + Integer.parseInt(interval)*intervalFactor);
            rule.setInt(RepeatRule.INTERVAL, Integer.parseInt(interval)*intervalFactor);
        } else if (intervalFactor != 1) {
            // Even if there is no interval, but the interval factor got
            // adjusted, we must set the INTERVAL accordingly
            Log.trace("Setting INTERVAL to: " + intervalFactor);
            rule.setInt(RepeatRule.INTERVAL, intervalFactor);
        }

        // <DayOfWeekMask>
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.DAY_OF_WEEK_MASK;
        final String dayOfWeekMaskAsString = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.DAY_OF_WEEK_MASK, false);
        if (!"".equals(dayOfWeekMaskAsString)) {
            final int dayOfWeekMask = Integer.parseInt(dayOfWeekMaskAsString);
            int BB_dow = SIFRepeatRuleHelper.parseDAY_OF_WEEK_MASK(dayOfWeekMask);
            if (BB_dow != 0) {
                Log.trace("Setting DAY IN WEEK: " + BB_dow);
                rule.setInt(RepeatRule.DAY_IN_WEEK, BB_dow);
            }
        }

        // <Instance> or WEEK_IN_MONTH
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.INSTANCE;
        final String instance = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.INSTANCE, false);// e.g. 2
        if (!"".equals(instance) && !"0".equals(instance)) {
            Log.trace("Setting WEEK IN MONTH: " + instance);
            rule.setInt(RepeatRule.WEEK_IN_MONTH, SIFRepeatRuleHelper.parseINSTANCE(Integer.parseInt(instance)));
        } else {
            // <DayOfMonth> 1-31
            SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.DAY_OF_MONTH;
            final String dayOfMonth = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.DAY_OF_MONTH, false);
            if (!"".equals(dayOfMonth) && Integer.parseInt(dayOfMonth) != 0) {
                Log.trace("Setting DAY IN MONTH: " + dayOfMonth);
                rule.setInt(RepeatRule.DAY_IN_MONTH, Integer.parseInt(dayOfMonth));
            }
        }
        
        // <MonthOfYear>
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.MONTH_OF_YEAR;
        final String monthOfYear = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.MONTH_OF_YEAR, false);
        int month = 0;
        if (!"".equals(monthOfYear)) {
            month = SIFRepeatRuleHelper.parseMONTH_OF_YEAR(Integer.parseInt(monthOfYear));
            if (month!=0) {
                // There is a bug in OS 4.5+ where setting the month
                // for events that recur yearly causes a calendar corruption,
                // for events recurring in January only.
                // In this case we avoid setting the occurrence date, and just
                // use the DATE as occurrence date. This causes some info to be
                // dropped, but a better solution would require us to store
                // extra information.
                String version[] = StaticDataHelper.getOSVersion();
                boolean patch = false;
                if (month == RepeatRule.JANUARY && olRecType == olRecursYearly && version.length > 1) {
                    int major = Integer.parseInt(version[0]);
                    int minor = Integer.parseInt(version[1]);
                    if (major == 4 && minor >= 5) {
                        Log.trace("RepeatRule patch will be applied, avoid setting MONTH_IN_YEAR");
                        patch = true;
                    }
                }
               
                // If we don't have to apply the patch, then we set all the
                // info, otherwise we just use the date as occurring date
                if (!patch) {
                    Log.trace("Setting MONTH IN YEAR: " + month + " " + monthOfYear);
                    rule.setInt(RepeatRule.MONTH_IN_YEAR, month);
                }
            }
        }

        // This is not managed in input
        // <NoEndDate>
        // final String noEndDate = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.NO_END_DATE, false);

        // <Occurences>
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.OCCURRENCES;
        final String occurrences = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.OCCURRENCES, false);
        if (!"".equals(occurrences))
        {
            rule.setInt(RepeatRule.COUNT, Integer.parseInt(occurrences));
        } else {
            // The field value is currently limited to RepeatRule.END (RIM API)
            // <PatternEndDate>
            // 20111106T230000Z
            SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.PATTERN_END_DATE;
            final String patternEndDate = PIMItemHelper.getValue(eventMap, SIFRepeatRuleHelper.PATTERN_END_DATE, false);
            if (!"".equals(patternEndDate))
            {
                if (allDay) {
                    Calendar date = PIMItemHelper.parseDateTime(patternEndDate);
                    date = DateUtil.getSafeTimeForAllDay(date);
                    long utcTime = date.getTime().getTime();
                    rule.setDate(RepeatRule.END, utcTime);
                } else {
                    long localTime = PIMItemHelper.parseDateTime(patternEndDate).getTime().getTime();
                    //localTime -=  PIMItemHelper.DAY_FACTOR;
                    if (extraGMTToLocal)
                    {
                        localTime = PIMItemHelper.convertGMTToLocal(localTime);
                    }
                    rule.setDate(RepeatRule.END, localTime);
                }
            }
        }

        // <Exceptions>.<ExcludeDate>
        SIFRepeatRuleHelper.SettingFieldName = SIFRepeatRuleHelper.EXCLUDE_DATE;
        Vector excludeDates = PIMItemHelper.getVectorValue(eventMap, SIFRepeatRuleHelper.EXCLUDE_DATE);
        for(int i=excludeDates.size()-1;0<=i;i--)
        {
            String tmp = (String)excludeDates.elementAt(i);
            if (tmp.length()>0)
            {
                rule.addExceptDate(PIMItemHelper.parseDateTime(tmp).getTime().getTime());
            }
        }
        
        excludeDates = null;
    }
} 
