/**
 * 
 */
package com.funambol.util.appenders;

import java.io.IOException;

import com.funambol.storage.DataAccessException;
import com.funambol.util.Appender;
import com.funambol.util.LogContent;
import com.funambol.util.ErrorLog;

public class ErrorInterceptAppender implements Appender {

    public ErrorInterceptAppender() {
        initLogFile();
    }

    private ErrorLog errors;

    public void closeLogFile() {
    }

    public void deleteLogFile() {
        errors.clearErrors();
    }

    public void initLogFile() {
        errors = new ErrorLog();
    }

    public void openLogFile() {
    }

    public void setLogLevel(int level) {
    }

    public void writeLogMessage(String level, String msg) throws DataAccessException {
        // TODO Auto-generated method stub
        if ("ERROR".equals(level)) {
            errors.addError(msg);
        }
    }
    
    public int numErrors() {
        return errors.numErrors();
    }

    public void clearErrors() {
        errors.clearErrors();
    }

    public String getErrors() {
        return errors.getErrors();
    }

    public LogContent getLogContent() throws IOException {
        throw new IOException("Cannot get log content for error intercept appender");
    }
}
